/* $Header: /src/carson/nistnet/monitor/RCS/hitutil.c,v 1.5 2000/03/22 16:54:13 carson Exp carson $ */

/* General-purpose utilities of various sorts used by the emulator
 * interface.  (Actually, just one right now.)
 */
#include "xincludes.h"
#include <signal.h>

/* It seems to be fairly common to have some DNS configuration problem
 * which results in gethostbyname, or more typically gethostbyaddr
 * queries to hang for a long time before timing out.  Since this attempts
 * two lookups per name, anyone who puts in a bunch of entries and has
 * a DNS problem needs to be very patient....  To get around this, we
 * put our own, shorter timeout around the queries.  Note that in some
 * cases, this may prove to be too short for a slow, but responding DNS
 * server.  If so, lengthen the timeout period used here.
 */

void
DNS_Timeout(int signo)
{
	return;
}

/* fixname - fix up a hostname to standard form */
void
fixname(char *hostname, unsigned long addr)
{
	struct hostent *hent=NULL;
	struct in_addr one;
	unsigned long was_addr = addr;
	void (*was_sig)(int);


	was_sig = signal(SIGALRM, DNS_Timeout);
	alarm(1);
	hent = gethostbyaddr((char *)&addr, sizeof(addr),  AF_INET);
	alarm(0);
	if (!hent) {	/* maybe they supplied name? */
		alarm(1);
		hent = gethostbyname(hostname);
		alarm(0);
		if (!hent) {	/* no luck, stick with addr */
			one.s_addr = was_addr;
			strcpy(hostname, inet_ntoa(one));
			(void) signal(SIGALRM, was_sig);
			return;
		}
	}
	(void) signal(SIGALRM, was_sig);
	strcpy(hostname, hent->h_name);
}
